// fccutilDlg.cpp : implementation file
//

#include "stdafx.h"
#include "sdcedit.h"
#include "sdceditDlg.h"

#include <winioctl.h>
#include <winbase.h>
#include <ntddndis.h>
#include <nuiouser.h>



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


DWORD driverVersion=0;

FILE *fp;
#define fLogPrint(feck) fp=fopen("fcculog.txt","a");fprintf feck;fclose(fp);
#define fLogTime() {   \
                     SYSTEMTIME systime; \
GetLocalTime(&systime);fp=fopen("fcculog.txt","a"); \
fprintf(fp," %02d:%02d:%02d \n",systime.wHour,systime.wMinute,systime.wSecond);fclose(fp);}

#define NUM_REG_ITEMS 10

WCHAR baseRegS[80] = _T("Comm\\SDCCF10G1\\Parms");

WCHAR elements[][20] = {
  _T("Frag Thresh"),
  _T("RTS Thresh"),
  _T("Power Save"),
  _T("B/G Mode"),
  _T("TX Power"),
  _T("RX Diversity"),
  _T("TX Diversity"),
  _T("Roam Trigger"),
  _T("Roam Delta"),
  _T("Roam Period"),

// old  
  _T("Radio"),
  _T("Rate"),
  _T("Locale"),
  _T("G Mode"),
  _T("G Protection"),
  _T("WME/WMM")
};

WCHAR keyS[][20] = {
  _T("frag"),
  _T("rts"),
  _T("PowerSaveMode"),
  _T("LegacyMode"),
  _T("PwrOut"),
  _T("RXdiv"),
  _T("TXdiv"),
  _T("RoamTrigger"),
  _T("RoamDelta"),
  _T("RoamPeriod"),

//old
  _T("RadioState"),
  _T("Rate"),
  _T("Locale"),
  _T("IBSSGMode"),
  _T("IBSSGProtection"),
  _T("WME")
};

/*
int num_sub_elements[] = {7,7,3,5,4,3,
// old ,2,5,6,5,3,2};
*/

int power_trans[] = {100,60,30,10,1};
//int rate_trans[]  = {0,2,4,11,22};
int frag_trans[]  = {2346,1998,1650,1302,954,606,256};
int rts_trans[] =   {2347,1956,1565,1174,783,392,0};
int rxDiv_trans[] = {0,1,3,2};
int txDiv_trans[] = {0,1,3};
int roamTrig_trans[] = {-50,-55,-60,-65,-70,-75};
int roamDelta_trans[] = {35,30,25,20,15};
int roamPeriod_trans[] = {30,25,20,15,10,5};
int pSave_trans[] = {0,1,2};

int legacy_trans[] = {0,1,2,3,4,5,6};

int num_sub_elements[] = {sizeof(frag_trans) / sizeof(int),
                          sizeof(rts_trans) / sizeof(int),
						  sizeof(pSave_trans) / sizeof(int),
						  sizeof(legacy_trans) / sizeof(int),
						  sizeof(power_trans) / sizeof(int),
						  sizeof(rxDiv_trans) / sizeof(int),
						  sizeof(txDiv_trans) / sizeof(int),
						  sizeof(roamTrig_trans) / sizeof(int),
						  sizeof(roamDelta_trans) / sizeof(int),
						  sizeof(roamPeriod_trans) / sizeof(int)};

int *global_trans[] = {frag_trans, rts_trans, pSave_trans, legacy_trans, power_trans, rxDiv_trans, txDiv_trans,
                       roamTrig_trans, roamDelta_trans, roamPeriod_trans};

int defaults[] = {0,0,0,0,0,2,2,4,2,3};
// old 0,0,0,4,0,0};
int reg_settings[] = {0,0,0,0,0,2,2,4,2,3};
// old 0,0,0,4,0,0};

#define GMODE_LEGACY_B		0
#define GMODE_AUTO		1
#define GMODE_ONLY		2
#define GMODE_B_DEFERRED	3
#define GMODE_PERFORMANCE	4
#define GMODE_LRS		5
#define GMODE_MAX		6



WCHAR sub_strings[][7][20] = {
{_T("2346"),_T("1998"),_T("1650"),_T("1302"),_T("954"),_T("606"),_T("256")},
{_T("2347"),_T("1956"),_T("1565"),_T("1174"),_T("783"),_T("392"),_T("0")},
{_T("Off"),_T("Max"),_T("Fast"),_T(""),_T(""),_T(""),_T("")},
{_T("B Only"),_T("G Auto"),_T("G Only"),_T("G B Defer"),_T("G Perf"),_T("G LRS"),_T("G MAX")},
{_T("100 mW"),_T("60 mW"),_T("30 mW"),_T("10 mW"),_T("1 mW"),_T(""),_T("")},

{_T("Main Only"),_T("Aux Only"),_T("On-start on Main"),_T("On-start on Aux"),_T(""),_T(""),_T("")},
{_T("Main Only"),_T("Aux Only"),_T("On"),_T(""),_T(""),_T(""),_T("")},

{_T("-50 dBm"),_T("-55 dBm"),_T("-60 dBm"),_T("-65 dBm"),_T("-70 dBm"),_T("-75 dBm"),_T("0")},
{_T("35 dBm"),_T("30 dBm"),_T("25 dBm"),_T("20 dBm"),_T("15 dBm"),_T(""),_T("")},
{_T("30 sec"),_T("25 sec"),_T("20 sec"),_T("15 sec"),_T("10 sec"),_T("5 sec"),_T("")},

{_T("Enabled"),_T("Disabled"),_T(""),_T(""),_T(""),_T(""),_T("")},
{_T("Auto"),_T("1 Mbit"),_T("2 Mbit"),_T("5.5 Mbit"),_T("11 Mbit"),_T(""),_T("")},
{_T("Worldwide"),_T("Thailand"),_T("Israel"),_T("Jordan"),_T("P.R. China"),_T("Japan"),_T("")},
{_T("Legacy B"),_T("LRS mode"),_T("Basic 54G"),_T("54G high"),_T("54G highest"),_T(""),_T("")},
{_T("Disabled"),_T("Local"),_T("Overlap"),_T(""),_T(""),_T(""),_T("")},
{_T("Disabled"),_T("Enabled"),_T(""),_T(""),_T(""),_T(""),_T("")}
};


/////////////////////////////////////////////////////////////////////////////
// CFccutilDlg dialog

CFccutilDlg::CFccutilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFccutilDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFccutilDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFccutilDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFccutilDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFccutilDlg, CDialog)
	//{{AFX_MSG_MAP(CFccutilDlg)
	ON_CBN_SELCHANGE(IDC_VALUE, OnSelchangeValue)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void GetSetting(HKEY key, int n, int *trans_table)
{
  DWORD status;
  ULONG value, size = 4, type=REG_DWORD;

  status = RegQueryValueEx (key, keyS[n], NULL, &type, (UCHAR *)&value, &size);

  if ((status != 0)  ||  (type != REG_DWORD))
  {
    reg_settings[n] = defaults[n];
    return;
  }

  if (trans_table == (int *) NULL)
    reg_settings[n] = value;
  else
  {
    for (int i=0;i<num_sub_elements[n];i++)
    {
      if (value == (ULONG)trans_table[i])
        break; 
    }

    reg_settings[n] = i;
  }

  if ((reg_settings[n] < 0)  ||  (reg_settings[n] >= num_sub_elements[n]))
      reg_settings[n] = defaults[n];

  return;
}

void GetRegSettings()
{
  HKEY hkey = NULL;
  DWORD status;
  int *trans;
  ULONG size = 4, type=REG_DWORD;

  hkey = NULL;

  status = RegOpenKeyEx (HKEY_LOCAL_MACHINE, baseRegS, NULL, KEY_QUERY_VALUE, &hkey);

  status = RegQueryValueEx (hkey, _T("DriverVersion"), NULL, &type, (UCHAR *)&driverVersion, &size);

  for (int i=0;i<NUM_REG_ITEMS;i++)
  {
    if (status == 0)
    {
	  trans = global_trans[i];
      
      GetSetting(hkey, i, trans);
    } 
    else
     reg_settings[i] = defaults[i];
  }

  if (hkey != (HKEY) NULL)
   RegCloseKey(hkey);


}


/////////////////////////////////////////////////////////////////////////////
// CFccutilDlg message handlers

BOOL CFccutilDlg::OnInitDialog()
{
   WCHAR buf[80];
   CStatic* pWnd;

   CDialog::OnInitDialog();

   // Set the icon for this dialog.  The framework does this automatically
   //  when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);			// Set big icon
   SetIcon(m_hIcon, FALSE);		// Set small icon
   
   CenterWindow(GetDesktopWindow());	// center to the hpc screen

   int i, index;

   GetRegSettings();

   CListBox *listBox;

   listBox = (CListBox*)GetDlgItem( IDC_LIST1 );
   listBox->ResetContent();
    
   for (i=0;i<NUM_REG_ITEMS;i++)
   {
     index = listBox->InsertString(i, elements[i]);
     listBox->SetItemData(index,i);
   }

   listBox->SetCurSel( 0 );


  CComboBox *valueBox;
  valueBox = (CComboBox*)GetDlgItem( IDC_VALUE );
  valueBox->ResetContent();
 
   for (i=0;i<num_sub_elements[0];i++)
   {
     index = valueBox->InsertString(i,sub_strings[0][i]);
     valueBox->SetItemData(index,i);
   }

   valueBox->SetCurSel( reg_settings[0] );


   if (driverVersion == 0)
     wsprintf(buf,_T("Cannot Access Driver Version"));
   else
	 wsprintf(buf,_T("Driver %d.%d.%d"),driverVersion>>16,(driverVersion & 0xff00)>>8, driverVersion&0xff);

   pWnd = (CStatic*)GetDlgItem( IDC_SDC_LABEL );
   if (pWnd != NULL)
	  pWnd->SetWindowText( buf );



 //  SetTimer( 2, 500, NULL);


/*
    WCHAR buf[20];
    CComboBox *ChannelBox,*TxPowerBox;
    CStatic* pWnd;

    int index,i;
    STCAPS caps;

	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

//set defaults

	m_antenna = 0;
	m_log_output = FALSE;
	m_test_type = 3;
	m_data_rate = 0;
	m_status1 = _T("");
	m_status2 = _T("");
	m_status3 = _T("");
	m_status4 = _T("");

// fill in combo boxes

   ChannelBox = (CComboBox*)GetDlgItem( IDC_CHANNEL );

   ChannelBox->ResetContent();
   for (i=1;i<=11;i++)
   {
     wsprintf( buf, _T("%d"),i);
     index = ChannelBox->AddString(buf);
     ChannelBox->SetItemData(index,i);
   }

   ChannelBox->SetCurSel( 0 );
*   
   if (!isCardThere())
   {
     AfxMessageBox( _T("No Cisco 350 Card found!!!! "));
     OnCancel();
     return FALSE;
   }
*
//   RadioOpen();
   caps.u16SoftwareVersion=0;
   GetCaps(caps);

   if (caps.u16SoftwareVersion == 0)
   {
     AfxMessageBox( _T("No Cisco 350 Card found!!!! "));
//     RadioClose();
     OnCancel();
     return FALSE;
   }

   TxPowerBox = (CComboBox*)GetDlgItem( IDC_TX_POWER );
   TxPowerBox->ResetContent();
   wsprintf( buf, _T("Max"),i);
   index = TxPowerBox->AddString(buf);
   TxPowerBox->SetItemData(index,0);

   for (i=0;i<8;i++)
   {
     if (caps.au16TxPowerLevels[i] != 0)
     {
        wsprintf( buf, _T("%d"),caps.au16TxPowerLevels[i]);
        index = TxPowerBox->AddString(buf);
        TxPowerBox->SetItemData(index,caps.au16TxPowerLevels[i]);
     }
   }

   TxPowerBox->SetCurSel( 0 );

   wsprintf(buf, _T("Start"));
   pWnd = (CStatic *) GetDlgItem( IDC_START_STOP);
   pWnd->SetWindowText(buf);

   UpdateData(FALSE);

//   RadioClose();

   isTestRunning=FALSE;

   return TRUE;  // return TRUE  unless you set the focus to a control
*/
   return TRUE;  // return TRUE  unless you set the focus to a control
}



void CFccutilDlg::OnSelchangeValue() 
{
	// TODO: Add your control notification handler code here

   int status;
   HKEY hkey;

   CListBox *listBox;
   CComboBox *valueBox;
   int *trans;

   listBox = (CListBox*)GetDlgItem( IDC_LIST1 );
   valueBox = (CComboBox*)GetDlgItem( IDC_VALUE );

   int listItem, value, regValue;

   listItem = listBox->GetCurSel();
   value = valueBox->GetCurSel();

   reg_settings[listItem] = value;

  trans = global_trans[listItem];
  regValue = trans[value];

  status = RegOpenKeyEx (HKEY_LOCAL_MACHINE, baseRegS, NULL, KEY_QUERY_VALUE, &hkey);

  if (status == 0)
  {
    RegSetValueEx(hkey, keyS[listItem],NULL,REG_DWORD,(UCHAR *) &regValue,4);
  }

  if (hkey != (HKEY) NULL)
   RegCloseKey(hkey);


}

void CFccutilDlg::OnSelchangeList1() 
{
	// TODO: Add your control notification handler code here
   CListBox *listBox;
   CComboBox *valueBox;
   listBox = (CListBox*)GetDlgItem( IDC_LIST1 );
   valueBox = (CComboBox*)GetDlgItem( IDC_VALUE );

   int listItem = listBox->GetCurSel();
   int i,index;

  valueBox->ResetContent();
 
   for (i=0;i<num_sub_elements[listItem];i++)
   {
     index = valueBox->InsertString(i,sub_strings[listItem][i]);
     valueBox->SetItemData(index,i);
   }

   valueBox->SetCurSel(reg_settings[listItem]);
	
}


void CFccutilDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
  CDialog::OnTimer(nIDEvent);

//   CStatic* pWnd;
//   WCHAR buf[80];

// wsprintf(buf, _T("Device 1\n"));

/*
   if (cardHandle == INVALID_HANDLE_VALUE)
   {
 wsprintf(buf, _T("Device 2\n"));
	 cardHandle = CreateFile(
     NDISUIO_DEVICE_NAME,
     GENERIC_READ | GENERIC_WRITE,
     FILE_SHARE_READ | FILE_SHARE_WRITE,
     NULL,
     OPEN_EXISTING,
     FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,
     INVALID_HANDLE_VALUE);
   }

     if (cardHandle != INVALID_HANDLE_VALUE)
	 {
	   ULONG bytes;
      DeviceIoControl(cardHandle, 
		  IOCTL_NDISUIO_OPEN_DEVICE, 
		  _T("SDCCF10G1"), 
		  18, NULL, 0, &bytes, NULL);
	 }

   if (cardHandle == INVALID_HANDLE_VALUE)
	 wsprintf(buf, _T("Device is not inserted\n"));
   else
   {
	 char Oidbuf[1024];
	 NDISUIO_QUERY_OID *oid = (NDISUIO_QUERY_OID *) Oidbuf;
	 oid->Oid = OID_802_11_RSSI;
	 oid->ptcDeviceName = NULL;
	 
     if (!DeviceIoControl(cardHandle, 
	    IOCTL_NDISUIO_QUERY_OID_VALUE, 
	    oid, sizeof(NDISUIO_QUERY_OID),
        NULL, 1024, (ULONG *) Oidbuf, NULL))
	 wsprintf(buf, _T("Cannot read rssi\n"));
	 else
	 {
	   LONG *val = (LONG *) oid->Data;
	   wsprintf(buf, _T("RSSI %d\n"),val);
	 }
   }

   pWnd = (CStatic*)GetDlgItem( IDC_SDC_LABEL );
   if (pWnd != NULL)
	  pWnd->SetWindowText( buf );
*/
}

